/****************************************/
/***                                  ***/
/***  tank battle sample  ver.1       ***/
/***                                  ***/
/***  > for at-mega48 20MHz           ***/
/***  > with ntsc_sprite04 & ntsc_bg2 ***/
/***    with new bit pattern          ***/
/***  > USART signal                  ***/
/***    at 115.2kbps8bits stop-bit 1  ***/
/***                                  ***/
/***  > win-avr 20070525              ***/
/***    + AVR-Studio 4.13 build 528   ***/
/***                                  ***/
/***  created :  2007.12.7            ***/
/***                      by m.suga   ***/
/***                                  ***/
/****************************************/




/*************************/
/***   include files   ***/
/*************************/

#include <avr/io.h>
#include <stdlib.h>
#include <avr/eeprom.h>




/***********************************/
/***   global variables declare  ***/
/***********************************/



/***   map data on eeprom   ***/

uint8_t __attribute__((section(".eeprom"))) val[][16] ={
		{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
		{9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9},
		{9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,9},
		{9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,9},
		{9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,9},
		{9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,9},
		{9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,9},
		{9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,9},
		{9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,9},
		{9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,9},
		{9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,9},
		{9,9,9,9,9,9,9,9,9,9,9,9,9,9,9,9}};



/***   keep S-RAM for actual map data   ***/

char map_actual[12][16];


/***   direction to rotation table   ***/

int8_t d2r[]={
		0,-1,-1,-1,-1,-1,-1,-1,-1,1,1,1,1,1,1,1,
		0,-1,-1,-1,-1,-1,-1,-1,-1,1,1,1,1,1,1,1};
					//O͖]
					//|P͍]
					//P͉E]
					//d2r[݂̕{PU|͂̕]
					//݂̕ɉZƓ͕ɏ]
					//]łB
					//A͕͂OEAQEA
					//ScPSEƂȂĂ邱ƁB


/***   mysin   ***/
					//100{̐l
int8_t r2s[]={
		0,38,71,92,100,92,71,38,
		0,-38,-71,-92,-100,-92,-71,-38};


/***   mycos   ***/
					//bnr100{̐l
int8_t r2c[]={
		100,92,71,38,0,-38,-71,-92,
		-100,-92,-71,-38,0,38,71,92};




/***   charactors position & direction  ***/

int16_t x[4];			//w100{̒li[
int16_t y[4];			//x100{̒li[
int8_t dir[4];			//i[
int16_t dx[4];			//ẅړ100{̒li[
int16_t dy[4];			//ẍړ100{̒li[

int8_t rot[4];			//]iGp)


/***   bullets position & direction  ***/

int16_t bx[4];			//w100{̒li[
int16_t by[4];			//x100{̒li[
int8_t bdir[4];			//i[
int16_t bdx[4];			//ẅړ100{̒li[
int16_t bdy[4];			//ẍړ100{̒li[

int8_t shot[4];			//˗LiOFˁAPF˒j



/***   number of dots   ***/

uint8_t dots;





/*****************************/
/***   functions declare   ***/
/*****************************/


void uart_putc(char c) {

	loop_until_bit_is_set(UCSR0A, UDRE0); //UDRErbg1ɂȂ܂ő҂
	UDR0 = c;					//f[^uartɏo͂

}


void set_sprite(unsigned char n,unsigned char x,unsigned char y,unsigned char p) {

	uart_putc(n*3);		//Ԗڂ̂wW
	uart_putc(x);		//@w
	uart_putc(n*3+1);	//Ԗڂ̂xW
	uart_putc(y);		//@w
	uart_putc(n*3+2);	//Ԗڂ̃p^[ԍ
	uart_putc(p);		//@w
}


void clear_all_sprite(void) {

	int i;

	for (i=0;i<25;i++) {
		set_sprite(i,0,0,0);
	}
}


int8_t dir_push() {

	uint8_t input_D;
	int8_t p_no;
							//{^͕_FȂ΂P
							//Ebt@bt@E@@@@nc nc
	input_D = PIND;

	switch (input_D & 0b00111100){
		case 0b00011100:		//E
			p_no = 0;
			break;
		case 0b00010100:		//E
			p_no = 2;
			break;
		case 0b00110100:		//
			p_no = 4;
			break;
		case 0b00110000:		//
			p_no = 6;
			break;
		case 0b00111000:		//
			p_no = 8;
			break;
		case 0b00101000:		//
			p_no = 10;
			break;
		case 0b00101100:		//
			p_no = 12;
			break;
		case 0b00001100:		//E
			p_no = 14;
			break;
		default:
			p_no = -1;
	}

							//EȂOAEȂQAȂSA
							//ȂUAcEȂPS
							//߂lɂB
	return p_no;
}


int button_push() {

	int input_D;
	int p_no;

							//{^͕_FȂ΂P
							//Ebt@bt@E@@@@nc nc
	input_D = PIND;
	p_no = input_D & 0b11000000;

	return p_no;
}



void background(uint8_t x,uint8_t y,uint8_t p_no)
{
	uart_putc(75);		//ꃌWX^i75=UARToCpXpj
	uart_putc(y*16 + x);	//wWAxW̍o͂

	uart_putc(75);		//ꃌWX^i75=UARToCpXpj
	uart_putc(p_no);	//wiԍo͂

}



void uart_init()
{
	DDRD = 0b00000011;	//ocQ`V͂ɃZbg
	DDRB = 0b11111111;	//a|[gׂďo̓[h

	UCSR0B = 0;			//܂AUfB[[uɐݒ
	UCSR0A = 0;			//UׂăNA

	UCSR0C = (1<<UCSZ01)|(1<<UCSZ00);	//8rbgAmpAXgbvP

	UBRR0H = 0x00;
	UBRR0L = 0x0A;			//0x000A = 10 (115.2kbps(20MHz))
							//0x0040 = 64 (19200bps (20MHz))    

	UCSR0B = (1<<TXEN0);	//ݒ芮ɁAMCl[uɐݒ
	 
}



void map_init()
{
	uint16_t eep_add;
	uint8_t i,k;

	for(k=0;k<12;k++){
		for(i=0;i<16;i++){
			eep_add = k*16+i;
			eeprom_busy_wait();
			map_actual[k][i] = eeprom_read_byte((uint8_t *)eep_add);
		}
	}
}



void position_init()
{
	uint8_t i;


	clear_all_sprite();

	/***   tanks positions & directions   ***/

	x[0] = 9600;
	y[0] = 5600;
	dir[0] = 4;
	dx[0] = 0;
	dy[0] = 0;		//mytank start position
	set_sprite(0,x[0]/100,y[0]/100,dir[0]+10);

	x[1] = 4000;
	y[1] = 2400;
	dir[1] = 4;
	dx[1] = 0;
	dy[1] = 0;
	rot[1] = 0;		//enemy tank 1 start position
	set_sprite(1,x[1]/100,y[1]/100,dir[1]+10+16);

	x[2] = 12800;
	y[2] = 8800;
	dir[2] = 4;
	dx[2] = 0;
	dy[2] = 0;
	rot[2] = 0;		//enemy tank 2 start position
	set_sprite(2,x[2]/100,y[2]/100,dir[2]+10+16);

	x[3] = 4000;
	y[3] = 8800;
	dir[3] = 4;
	dx[3] = 0;
	dy[3] = 0;
	rot[3] = 0;		//enemy tank 3 start position
	set_sprite(3,x[3]/100,y[3]/100,dir[3]+10+16);


	/***   bullets positions & directions   ***/

	for (i=0;i<4;i++){
		bx[i] = 0;
		by[i] = 0;
		bdir[i] = 0;
		bdx[i] = 0;
		bdy[i] = 0;
		shot[i] = 0;
	}

}



void mytank_moving()
{
	/*************************/
	/***   mytank moving   ***/
	/*************************/


	int8_t button_dir;

	uint16_t xx;
	uint16_t yy;


	/***   input buttons   ***/

	button_dir = dir_push();

	if (button_dir != -1) {
					//݂̕Ɠ͕ɏ]]
		dir[0] = dir[0] + d2r[dir[0] + 16 - button_dir];

		if (dir[0] == 16 ) {
			dir[0] = 0;
		}

		if (dir[0] == -1 ) {
			dir [0] = 15;
		}
					//ɏ]wx̑rhmAbnr
					//100{lƂăZbgB
		dx[0] = r2c[dir[0]];
		dy[0] = -r2s[dir[0]];

	}else {
		dx[0] = 0;
		dy[0] = 0;
	}


					//Ƃ낪ubNH
					//ubNȂΑOɐi
	xx = (x[0] - 1600 + dx[0] + 300) / 800;
	yy = (y[0] - 800 + dy[0] + 300) / 800;

	if (map_actual[yy][xx] != 9) {
		x[0] = x[0] + dx[0];
		y[0] = y[0] + dy[0];
	}

}




void enemy_moving()
{
	/************************/
	/***   enemy moving   ***/
	/************************/

	uint8_t k,r;

	uint16_t xx;
	uint16_t yy;


	/***  loop 3 times   ***/

	for (k=1;k<4;k++){

		/***   changing direction   ***/

		r = rand() / 0x199A;	//O`S̗𔭐

							//P^PO̊mŉ]ύX
		if (r == 0) {
							//|P`{P͈̗̔͂ɐݒ
			rot[k] = (rand()/0x2aab) -1;
		}

							//݂̉]isɔf
		dir[k] = dir[k] + rot[k];
		if (dir[k] == 16 ) {
			dir[k] = 0;
		}

		if (dir[k] == -1 ) {
			dir [k] = 15;
		}

					//ɏ]wx̑rhmAbnr
					//100{lƂăZbgB
		dx[k] = r2c[dir[k]];
		dy[k] = -r2s[dir[k]];

					//Ƃ낪ubNH
					//ubNȂΑOɐi
		xx = (x[k] - 1600 + dx[k] + 300) / 800;
		yy = (y[k] - 800 + dy[k] + 300) / 800;

		if (map_actual[yy][xx] != 9) {
			x[k] = x[k] + dx[k];
			y[k] = y[k] + dy[k];
		}

	}

}



void update_sprites()
{
	/**************************/
	/***   update sprites   ***/
	/**************************/


	uint8_t k;



	/***   draw all charactors   ***/

	set_sprite(0,x[0]/100,y[0]/100,dir[0]+10);

	for (k=1;k<4;k++) {

		set_sprite(k,x[k]/100,y[k]/100,dir[k]+26);

	}

}




void wait_timing()
{
	/***********************/
	/***   wait timing   ***/
	/***********************/


	uint8_t k;
	uint16_t j;


	for (k=0;k<10;k++) {
		for (j=0;j<10000;j++);
	}		//  ԉ҂

}







/*****************************************/
/*****************************************/
/***          main   function          ***/
/*****************************************/
/*****************************************/


int main(void)
{
	/*****************************/
	/***   variables declare   ***/
	/*****************************/

	uint8_t k;
	uint16_t j;


	/************************/
	/*****  initialize  *****/
	/************************/


	/***   usart init.   ***/

	uart_init();


	/***   sprite unit init.   ***/

	uart_putc(0xff);	//0xff𑗂āAf[^V[PXNA


	/***   S-RAM map data init.   ***/

	map_init();


	/***   background init.   ***/

	background(0,15,3);			//wi􂢑ւ
								//3:lptB[ĥ
								//0,15cwiS􂢑ւ

	/***   charactor position init.   ***/

	position_init();


	/***   waiting (or start music)   ***/

					//ŁAʃX^[g̉y
	for (k=0;k<200;k++) {
		for (j=0;j<10000;j++);
	}




	/***********************/
	/*****  main loop  *****/
	/***********************/



	for (;;) {


		mytank_moving();
		enemy_moving();

		update_sprites();

		wait_timing();

	}

}

